--MAIN WINDOW
local UIConfig = CreateFrame("Frame", "LootRoll", UIParent, "BasicFrameTemplateWithInset");
UIConfig:SetSize(300,100);
UIConfig:SetPoint("CENTER", UIParent, "CENTER");
UIConfig:SetMovable(true);
UIConfig:EnableMouse(true);
UIConfig:RegisterForDrag("LeftButton");
UIConfig:SetScript("OnDragStart", UIConfig.StartMoving)
UIConfig:SetScript("OnDragStop", UIConfig.StopMovingOrSizing)
UIConfig.title = UIConfig:CreateFontString(nil,"OVERLAY");
UIConfig.title:SetFontObject("GameFontHighlight");
UIConfig.title:SetPoint("LEFT", UIConfig.TitleBg, "left", 5, 0);
UIConfig.title:SetText("Loot Roll");

--STATIC INPUT FOR MANUAL ROLL
StaticPopupDialogs["ManualRolling"] = {
	text = "Enter roll (Max: 999999):",
	button1 = "Accept",
	button2 = "Cancel",
	hasEditBox = 1,
	maxLetters = 6,
	OnShow = function(self)
		local editBox = self.editBox
		editBox:SetText("")
		editBox:SetFocus()
	end,
	OnAccept = function(self)
		manualRoll(self);
	end,
	EditBoxOnEnterPressed = function(self)
		manualRoll(self:GetParent());
	end,
	EditBoxOnEscapePressed = function(self)
		self:GetParent():Hide()
	end,
	timeout = 0,
	whileDead = 1,
	hideOnEscape = 1
}


--ITEM PREVIEW

UIConfig.itemButton = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
UIConfig.itemButton:SetPoint("CENTER", UIConfig, "TOP", -110, -60);
UIConfig.itemButton:SetSize(60,60);
UIConfig.itemButton.tex = UIConfig:CreateTexture(nil, "BACKGROUND");
UIConfig.itemButton.tex:SetAllPoints();

UIConfig.itemButton.MyTexture = UIConfig.itemButton:CreateTexture(nil,"OVERLAY");
UIConfig.itemButton.MyTexture:SetPoint("TOPLEFT", 2, -2);
UIConfig.itemButton.MyTexture:SetPoint("BOTTOMRIGHT", -2, 2);
UIConfig.itemButton:SetScript("OnLeave", function(self) GameTooltip:Hide() ResetCursor() end);


-- BUTTONS
--MAINSPECC
UIConfig.mainSpeccButton = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
UIConfig.mainSpeccButton:SetPoint("CENTER", UIConfig, "TOP", -15, -45);
UIConfig.mainSpeccButton:SetSize(100,30);
UIConfig.mainSpeccButton:SetText("Main");
UIConfig.mainSpeccButton:SetNormalFontObject("GameFontNormalLarge");
UIConfig.mainSpeccButton:SetHighlightFontObject("GameFontHighLightLarge");
UIConfig.mainSpeccButton:SetScript("OnClick", function(self) RandomRoll(1,100) UIConfig:Hide() end);

--OFFSPECC
UIConfig.offSpeccButton = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
UIConfig.offSpeccButton:SetPoint("CENTER", UIConfig, "TOP", -15, -75);
UIConfig.offSpeccButton:SetSize(100,30);
UIConfig.offSpeccButton:SetText("Off");
UIConfig.offSpeccButton:SetNormalFontObject("GameFontNormalLarge");
UIConfig.offSpeccButton:SetHighlightFontObject("GameFontHighLightLarge");
UIConfig.offSpeccButton:SetScript("OnClick", function(self) RandomRoll(1,1) UIConfig:Hide() end);

--MOG
UIConfig.mogButton = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
UIConfig.mogButton:SetPoint("CENTER", UIConfig, "TOP", 85, -45);
UIConfig.mogButton:SetSize(100,30);
UIConfig.mogButton:SetText("Mog");
UIConfig.mogButton:SetNormalFontObject("GameFontNormalLarge");
UIConfig.mogButton:SetHighlightFontObject("GameFontHighLightLarge");
UIConfig.mogButton:SetScript("OnClick", function(self) RandomRoll(1,6) UIConfig:Hide() end);		

--OTHER
UIConfig.otherRoll = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
UIConfig.otherRoll:SetPoint("CENTER", UIConfig, "TOP", 85, -75);
UIConfig.otherRoll:SetSize(100,30);
UIConfig.otherRoll:SetText("Other");
UIConfig.otherRoll:SetNormalFontObject("GameFontNormalLarge");
UIConfig.otherRoll:SetHighlightFontObject("GameFontHighLightLarge");
UIConfig.otherRoll:SetScript("OnClick", function(self) StaticPopup_Show("ManualRolling") end);

UIConfig:Hide();


--MAIN CODE--

--Function for handling the manual rolls.
function manualRoll(self)
	local editBox = self.editBox
	local text = editBox:GetText()
	local number = tonumber(text)
	if not (number == 0 or number == "" or number == nil) then
		UIConfig:Hide();
		RandomRoll(1,number);
	end
	self:Hide()
end

local Roll_EventFrame = CreateFrame("Frame")
Roll_EventFrame:RegisterEvent("CHAT_MSG_RAID_WARNING");
Roll_EventFrame:SetScript("OnEvent", 
    function(self, event, ...)
		local arg1, arg2 = ...
		--if arg2 == "Actuarius-Silvermoon" or arg2 == "Luria-Silvermoon" or arg2 == "Teldryn-Silvermoon" then
		local name = arg2:match("(%a+)");
		--print(name);
		if(UnitIsGroupLeader(name)) then
			--print(arg1);
			local _,playerClass = UnitClass("Player");
			--print(playerClass);
			
			--Class array to store what each class can and can't equip.
			local classArray = {
				{"DEATHKNIGHT",{"Plate","One-Handed Axes","Two-Handed Axes","One-Handed Swords","Two-Handed Swords","One-Handed Maces", "Two-Handed Maces", "Polearms"}},
				{"DEMONHUNTER",{"Leather","Warglaives","Fist Weapons", "One-Handed Axes", "One-Handed Swords"}},
				{"DRUID",{"Leather","One-Handed Maces","Two-Handed Maces","Polearms","Staves","Daggers","Fist Weapons"}},
				{"HUNTER",{"Mail","One-Handed Axes","Two-Handed Axes","One-Handed Swords","Two-Handed Swords","Polearms","Staves","Daggers", "Fist Weapons","Bows","Crossbows","Guns"}},
				{"MAGE",{"Cloth","One-Handed Swords","Staves","Daggers","Wands"}},
				{"MONK",{"Leather","One-Handed Axes","One-Handed Swords","One-Handed Maces","Polearms","Staves","Fist Weapons"}},
				{"PALADIN",{"Plate","Shield","One-Handed Axes","Two-Handed Axes","One-Handed Swords","Two-Handed Swords","One-Handed Maces", "Two-Handed Maces", "Polearms"}},
				{"PRIEST",{"Cloth","One-Handed Maces","Staves","Daggers","Wands"}},
				{"ROGUE",{"Leather","One-Handed Axes","One-Handed Swords","One-Handed Maces","Daggers","Fist Weapons","Bows","Crossbows","Guns"}},
				{"SHAMAN",{"Mail","Shield","One-Handed Axes","Two-Handed Axes","One-Handed Maces","Two-Handed Maces","Staves","Daggers","Fist Weapons"}},
				{"WARLOCK",{"Cloth","One-Handed Swords","Staves","Daggers","Wands"}},
				{"WARRIOR",{"Plate","Shield","One-Handed Axes","Two-Handed Axes","One-Handed Swords","Two-Handed Swords","One-Handed Maces", "Two-Handed Maces","Polearms","Staves","Daggers", "Fist Weapons","Bows","Crossbows","Guns"}}
			};
			
			local _,link,_,_,_,itemType,itemSubTybe,_,invType = GetItemInfo(arg1)
			local boolean = false;
			
			--Determine if the player's class can equip the armor.
			for i,v in ipairs(classArray) do 
				if(v[1] == playerClass) then
					for j,k in ipairs(v[2]) do
						if(k==itemSubTybe) then
							boolean = true;
							break;
						end
					end
					break;
				end
			end;
			
			--print(boolean);
			--print(GetItemInfo(link));
			
			--Make sure there is an item, that the item is a weapon or armor, and that it is either equiipable by player class or subType Misc or a cloak, which all classes can equip.
			if not (link == nil or link == "") and (itemType == "Armor" or itemType == "Weapon") and (boolean or itemSubTybe == "Miscellaneous" or invType == "INVTYPE_CLOAK") then
				local id = link:match("item:(%d+):");
				
				UIConfig.itemButton:SetScript("OnMouseDown", function(self,button) if(IsShiftKeyDown() and button=="RightButton") then OpenAzeriteEmpoweredItemUIFromLink(link) elseif (IsControlKeyDown() and button=="LeftButton") then DressUpItemLink(link) end end);
				UIConfig.itemButton:SetNormalTexture(GetItemIcon(id));
				UIConfig.itemButton:SetScript("OnEnter", function(self) GameTooltip:SetOwner(self, "ANCHOR_CURSOR"); GameTooltip:ClearLines(); GameTooltip:SetHyperlink(link); GameTooltip:Show() end);
								
				UIConfig:Show();
			end
		end
	end
)